summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Lockywolf2024-03-20 13:57:13 +0100
committer Willy Sudiarto Raharjo2024-03-20 10:33:41 +0100
commit3159dc924e961694ffe1aa99c460bba6be1aed77 (patch)
treee6e9f42aff21f702f1490b3a790edb3636ed8ea5
parent9f74d04686c99f14cec5c1d8dbd96f22ded61163 (diff)
downloadslackbuilds-3159dc924e961694ffe1aa99c460bba6be1aed77.tar.gz
libraries/ospray: Added (Ray Tracing Engine).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/ospray/README25
-rw-r--r--libraries/ospray/ospray.SlackBuild119
-rw-r--r--libraries/ospray/ospray.info10
-rw-r--r--libraries/ospray/slack-desc19
4 files changed, 173 insertions, 0 deletions
diff --git a/libraries/ospray/README b/libraries/ospray/README
new file mode 100644
index 0000000000..93d0e6d8fe
--- /dev/null
+++ b/libraries/ospray/README
@@ -0,0 +1,25 @@
+Intel® OSPRay is an open source, scalable, and portable ray tracing
+engine for high-performance, high-fidelity visualization on Intel
+Architecture CPUs, Intel Xe GPUs, and ARM64 CPUs. OSPRay is part of the
+Intel oneAPI Rendering Toolkit and is released under the permissive
+Apache 2.0 license.
+
+The purpose of OSPRay is to provide an open, powerful, and easy-to-use
+rendering library that allows one to easily build applications that use
+ray tracing based rendering for interactive applications (including
+both surface- and volume-based visualizations). OSPRay runs on anything
+from laptops, to workstations, to compute nodes in HPC systems.
+
+OSPRay internally builds on top of Intel Embree, Intel Open VKL, and
+Intel Open Image Denoise. The CPU implementation is based on Intel ISPC
+(Implicit SPMD Program Compiler) and fully exploits modern instruction
+sets like Intel SSE4, AVX, AVX2, AVX-512 and NEON to achieve high
+rendering performance. Hence, a CPU with support for at least SSE4.1 is
+required to run OSPRay on x86_64 architectures, or a CPU with support
+for NEON is required to run OSPRay on ARM64 architectures.
+
+OSPRay’s GPU implementation (beta status) is based on the SYCL
+cross-platform programming language implemented by Intel oneAPI Data
+Parallel C++ (DPC++) and currently supports Intel Arc™ GPUs on Linux
+and Windows, and Intel Data Center GPU Flex and Max Series on Linux,
+exploiting ray tracing hardware support.
diff --git a/libraries/ospray/ospray.SlackBuild b/libraries/ospray/ospray.SlackBuild
new file mode 100644
index 0000000000..6fecf1b243
--- /dev/null
+++ b/libraries/ospray/ospray.SlackBuild
@@ -0,0 +1,119 @@
+#!/bin/bash
+
+# Slackware build script for ospray
+
+# Copyright 2024
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=ospray
+VERSION=${VERSION:-3.1.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} +
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DCMAKE_CXX_COMPILER_LAUNCHER=ccache \
+ -DCMAKE_C_COMPILER_LAUNCHER=ccache \
+ -DOSPRAY_ENABLE_APPS_TESTING=OFF \
+ -D OSPRAY_MODULE_DENOISER=ON \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+CHANGELOG.md SECURITY.md STYLEGUIDE.md LICENSE.txt README.md doc \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mv $PKG/usr/share/doc/* $PKG/usr/doc/$PRGNAM-$VERSION/
+rm -rf $PKG/usr/share/doc
+rmdir $PKG/usr/share
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/ospray/ospray.info b/libraries/ospray/ospray.info
new file mode 100644
index 0000000000..e98dcd041c
--- /dev/null
+++ b/libraries/ospray/ospray.info
@@ -0,0 +1,10 @@
+PRGNAM="ospray"
+VERSION="3.1.0"
+HOMEPAGE="https://www.ospray.org/"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://github.com/ospray/ospray/archive/v3.1.0/ospray-3.1.0.tar.gz"
+MD5SUM_x86_64="cc97ca01d402b63cc4c091fc796a9b80"
+REQUIRES="openvkl googlebenchmark openimagedenoise"
+MAINTAINER="Lockywolf"
+EMAIL="for_sbo.ospray_2024-03-02@lockywolf.net"
diff --git a/libraries/ospray/slack-desc b/libraries/ospray/slack-desc
new file mode 100644
index 0000000000..6bb3a44382
--- /dev/null
+++ b/libraries/ospray/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+ospray: ospray (Ray Tracing Based Rendering Engine)
+ospray:
+ospray: Intel OSPRay is an open source, scalable, and portable ray tracing
+ospray: engine for high-performance, high-fidelity visualization on Intel
+ospray: Architecture CPUs, Intel Xe GPUs, and ARM64 CPUs. OSPRay is part of
+ospray: the Intel oneAPI Rendering Toolkit and is released under the
+ospray: permissive Apache 2.0 license.
+ospray:
+ospray:
+ospray:
+ospray: